# -*- coding: utf8 -*-

import urllib2, time, inspect, sys, re, csv, cPickle
import htmlparser, curvas, repartidor, cgi
import os

import mod_mysql, infoauth
dbusr, dbclv = infoauth.load("/home/facundo/roundup/infodb")
bdd = mod_mysql.DataBase("localhost", dbusr, dbclv, "roundup")

VARIABS = "version priority severity keyword".split()
URL_CSV = "http://bugs.python.org/issue?@action=export_csv&@columns=id,title,keywords,priority,versions,severity&@sort=creation&@filter=status&status=1,3"
URL_BASE = "http://bugs.python.org/%s"
FFECHA = "%Y-%m-%d"
NOPRE = re.compile("<pre>.*?</pre>", re.S)

def log(*msgs):
    fech = time.ctime()
    caller = inspect.stack()[1][3]
    print "%s  (%s) - %s" % (fech, caller, " ".join(str(x) for x in msgs))

def getItem(reqid, n):
    url = URL_BASE % reqid
    log("Abriendo la URL %s (%d)" % (url, n))
    intentos = 0
    while intentos<3:
        try:
            u = urllib2.urlopen(url)
            pag = u.read()
            break
        except:
            log("    reintentando...")
            intentos += 1
    else:
        raise

    # sanitizamos
    pag = NOPRE.sub("", pag)

#    log("Parseando...")
    constr = htmlparser.tableConstructor()
    h = htmlparser.MyHTMLParser(constr)
    h.feed(pag)
    h.close()

    # tenemos varias tablas, nos quedamos con la que queremos
    tablas = constr.all_tablas
    history = messages = None
    for tabla in tablas[2:]:
        if tabla.attrs["class"] == "history":
            history = tabla
        if tabla.attrs["class"] == "messages":
            messages = tabla
    if history is None:
        raise ValueError("No tengo tabla history (%r)" % history)

    elementos = []
    actividades = []

    # en history los primeros dos son vacios
    assert history[0] == ["History"]
    assert history[1] == ["Date", "User", "Action", "Args"]
    assert history[-1][2] == "create"
    history = history[2:]
    for date,user,action,args in history:
        elementos.append((date, str(user)))
        actividades.append(time.mktime(time.strptime(date[:10], FFECHA)))

    # en messages
    if messages is not None:
        assert messages[0][0].startswith("Messages")
        for mes in messages[1:]:
            if len(mes) != 4:
                continue
            (nromes, autor, date, algo) = mes

            assert autor[:8] == "Author: "
            autor = autor[8:]
            assert date[:6] == "Date: "
            date = date[6:]
            elementos.append((date, str(autor)))
            actividades.append(time.mktime(time.strptime(date[:10], FFECHA)))

    # tomamos los valores
    actividades.sort()
    elementos.sort()
#    print "elementos", elementos
    creat_dt = elementos[0][0][:10]
    creat_by = elementos[0][1]
    lastc_dt = elementos[-1][0][:10]
    lastc_by = elementos[-1][1]
    return (creat_by, creat_dt, lastc_by, lastc_dt, actividades)



def toLista(cad):
    vals = re.findall(r"['\"](\d+)['\"]", cad)
    vals = list(set(vals))
    return map(int, vals)

def toInt(x):
    if x == 'None':
        return 0
    return int(x)

def getTabla():
    log("Leyendo la lista de issues")
    u = urllib2.urlopen(URL_CSV)
    info = u.read()
    lins = csv.reader(info.splitlines())
    dest = []
    assert lins.next() == ['id', 'title', 'keywords', 'priority', 'versions', 'severity']
    for linea in (x for x in lins if x):
        (elemid, title, keywords, priority, versions, severity) = linea
        dest.append((int(elemid), title, toLista(keywords), toInt(priority), toLista(versions), toInt(severity)))
    return dest

def getVars(var):
    log("Leyendo la variable %r" % var)
    # levantamos de disco lo de siempre
    nomarch = "vars_%s.pickle" % var
    if os.access(nomarch, os.R_OK):
        a = open(nomarch)
        variable = cPickle.load(a)
        a.close()
    else:
        variable = {}

    # traemos de la web
    url = URL_BASE % var
    u = urllib2.urlopen(url)
    pag = u.read()
    constr = htmlparser.tableConstructor()
    h = htmlparser.MyHTMLParser(constr)
    h.feed(pag)
    h.close()

    # sacamos el titulo y aclaraciones con ()
    lineas = []
    for lin in constr.all_tablas[0][1:]:
        if " (" in lin:
            lin = lin[:lin.find(" (")]
        lineas.append(lin)

    if var == "keyword":
        cods = (x[0] for x in lineas)
        d = dict((int(c.link[7:]), str(c)) for c in cods)
    else:
        d = dict((int(str(lin[0])), str(lin[2])) for lin in lineas)
    d[0] = "-"

    # actualizamos y grabamos nuevamente
    variable.update(d)
    a = open(nomarch, "w")
    cPickle.dump(variable, a)
    a.close()

    return variable

def sanitizar(txt):
    txt = txt.replace("\\", "\\\\").replace("'", "\\'")
    txt = cgi.escape(txt)
    return txt

DIAS7 = 3600*24*7
DIAS60 = 3600*24*60
DIAS365 = 3600*24*365
AHORA = time.time()
def _periodo(viejo):
    segs = AHORA - viejo
    if segs < DIAS7:
        return "semana"
    if segs < DIAS60:
        return "dosmeses"
    if segs < DIAS365:
        return "anio"
    return "reviejo"

def _dic2lin(dic, nom=None):
    txt = ""
    for k in sorted(dic):
        v = dic[k]
        if nom is not None:
            try:
                k = nom[k]
            except KeyError:
                print "Lost name for value %r in %r" % (k, nom)
                raise
        txt += "%s:%s, " % (k, v)
    txt = txt[:-2]
    return txt

def agregaHistorial(items, infoitems, variables):
    # contamos
    viejo = {}
    activ = {}
    kwrds = {}
    versn = {}
    for item in items:
        (elemid, title, keywords, priority, versions, severity) = item
        (creat_by, creat_dt, lastc_by, lastc_dt, activs) = infoitems[elemid]

        edad = _periodo(time.mktime(time.strptime(creat_dt, FFECHA)))
        vivo = _periodo(time.mktime(time.strptime(lastc_dt, FFECHA)))

        viejo[edad] = viejo.get(edad, 0) + 1
        activ[vivo] = activ.get(vivo, 0) + 1
        for kw in keywords:
            kwrds[kw] = kwrds.get(kw, 0) + 1
        for vs in versions:
            versn[vs] = versn.get(vs, 0) + 1

    nomkw = variables["keyword"]
    nomvs = variables["version"]

    linea = time.strftime("%Y-%m-%d %H:%M:%S") + ";"
    linea += _dic2lin(viejo) + ";"
    linea += _dic2lin(activ)+ ";"
    linea += _dic2lin(kwrds, nomkw)+ ";"
    linea += _dic2lin(versn, nomvs)

    # bajamos el historial
    hist = open("rounduphist.txt", "a")
    hist.write(linea + "\n")

def main(hilos):
    # sacamos los items y excluimos el titulo
    items = getTabla()
    variables = dict((var,getVars(var)) for var in VARIABS)
#    items = items[:20]

    # buscamos la info de cada item
    log("Levantamos %d registros" % len(items))
    data = []
    for n, item in enumerate(items):
        data.append((item[0], n))

    allactivs = []
    infoitems = {}
    repart = repartidor.Repartidor(getItem, hilos)
    for (carga, result) in repart.procesar(data):
        (reqid, n) = carga
        (creat_by, creat_dt, lastc_by, lastc_dt, activs) = result
        allactivs.extend(activs)
        stractivs = ", ".join(str(int(x)) for x in activs)
        infoitems[reqid] = (creat_by, creat_dt, lastc_by, lastc_dt, stractivs)
    repart.fin()

    agregaHistorial(items, infoitems, variables)

    # generamos el png con la curva de actividad
    activcont = {}
    for activ in allactivs:
        activ = int( activ // (3600*24))
        activcont[activ] = activcont.get(activ, 0) + 1
    desde = min(activcont.keys())
    hasta = max(activcont.keys())
    activsok = [activcont.get(dia, 0) for dia in range(desde,hasta+1)]
    curvas.plotCurva(activsok, (800, 100), "trafico.png")

    # variables en BD y disco
    for (nom, valores) in variables.items():
        bdd.accion("truncate table %s;" % nom)
        for (cod, descrip) in valores.items():
            bdd.accion("insert into %s values (%d, '%s');" % (nom, cod, descrip))
    arch = open("variables.info", "w")
    cPickle.dump([time.time(), variables], arch, -2)
    arch.close()

    def val2txt(variab, vals):
        dic = variables[variab]
        return ", ".join(dic[v] for v in vals)

    # items en la BD
    bdd.accion("truncate table items;")
    bdd.accion("truncate table item_keywords;")
    bdd.accion("truncate table item_versions;")
    for item in items:
        (elemid, title, keywords, priority, versions, severity) = item
#        print item
        (creat_by, creat_dt, lastc_by, lastc_dt, activs) = infoitems[elemid]
        title = sanitizar(title)
        creat_by = sanitizar(creat_by)
        lastc_by = sanitizar(lastc_by)
#        print (elemid, title, priority, severity, creat_by, creat_dt, lastc_by, lastc_dt), keywords
        all_keywords   = val2txt("keyword", keywords)
        all_versions   = val2txt("version", versions)
        bdd.accion("insert into items values (%d, '%s', %d, %d, '%s', '%s', '%s', '%s', '%s', '%s', '%s');" %
                    (elemid, title, priority, severity, creat_by, creat_dt, lastc_by, lastc_dt, all_versions, all_keywords, activs))

        # otras tablas
        for val in keywords:
            bdd.accion("insert into item_keywords values (%d, %d);" % (elemid, val))
        for val in versions:
            bdd.accion("insert into item_versions values (%d, %d);" % (elemid, val))
    return


if __name__ == "__main__":
    if len(sys.argv) == 2:
        hilos = int(sys.argv[1])
    else:
        hilos = 20
    main(hilos)
